//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "main.h"
#include "Board.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TForm1 *Form1;
//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner)
        : TForm(Owner)
{
}
//---------------------------------------------------------------------------
void __fastcall TForm1::FormCreate(TObject *Sender)
{
  // -      
  // Desk: TStringGrid
  for(int i = 1; i < 9; i++)
    {
      Desk->Cells[i][0] = IntToStr(i);
      Desk->Cells[0][i] = IntToStr(i);
    }
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Button1Click(TObject *Sender)
{
  for(int i=1; i<9; i++)
    for(int j=1; j<9; j++)
      Desk->Cells[i][j] = ' ';

  //   Board
  Board b;

  //      
  int pos[8][2];

  //   ,   
  // ""      .
  //(  -  ).
  int moves[8][8];

  //  8 .
  for(int k = 0; k < 8; k++)
   {
     //   
     for(int i = 0; i < 8; i++)
       for(int j = 0; j < 8; j++)
         moves[i][j] = b.TestSquare(i,j);

     //   moves[]   ,
     //      pos[].
     FindMin(moves, pos[k][0], pos[k][1]);

     // 
     b.SetQueen(pos[k][0], pos[k][1]);

     //      
     //TStringGrid
     Desk->Cells[pos[k][1]+1][pos[k][0]+1] = '';
   }
}
//---------------------------------------------------------------------------
/*
      moves
(     == 0), ,  
  ,   
  .     
(x1, y1).
*/
void TForm1::FindMin(int m[8][8], int& x1, int& y1)
{
  int x = 0;
  int y = 0;
  int count = 0; //   
                 //
  int min = 100;

  //     
  // .     == 0.
  for(int i = 0; i<8; i++)
    for(int j = 0; j<8; j++)
      if(m[i][j] < min && m[i][j] != 0)
        {
           min = m[i][j];
           x = i;
           y = j;
           count = 1;
        }
      else if(m[i][j] == min)
             count++;

  //  .   .
  if(count == 0) Application->MessageBoxA("  ",
                             " ", MB_OK);

  //       0  count
  else
  {
       srand(time(NULL));
       count = rand()%count;

       //  , 
       // 
       for(int i = 0; i<8; i++)
         for(int j = 0; j<8; j++)
          {
            if(m[i][j] == min && count == 0)
             {x = i;
              y = j;}
            if(m[i][j] == min)
              count--;
          }

       //   
       x1 = x;
       y1 = y;
  }
}
//---------------------------------------------------------------------------

